From a5c9dc660dea958bb256e7f6019fe84df39aea6c Mon Sep 17 00:00:00 2001
From: Veerabhadrarao Badiganti <vbadigan@codeaurora.org>
Date: Fri, 22 Feb 2019 10:45:55 +0530
Subject: [PATCH 05/18] storage: Use gpio based card detection to check card
 presence

Use gpio based card detction mechanism to check the card presence
for removable cards. If cd-gpio is supplied, use it for card
detection else continue using present state register.

Change-Id: I6ad405301c19d3409ed0ba91e0bbe3c06048eb7b
Signed-off-by: Veerabhadrarao Badiganti <vbadigan@codeaurora.org>
Signed-off-by: Nitheesh Sekar <nsekar@codeaurora.org>
---
 src/drivers/storage/sdhci.c | 9 +++++++--
 src/drivers/storage/sdhci.h | 8 ++++++++
 2 files changed, 15 insertions(+), 2 deletions(-)

diff --git a/src/drivers/storage/sdhci.c b/src/drivers/storage/sdhci.c
index ab8caa5e3b0d..bc900a5195b8 100644
--- a/src/drivers/storage/sdhci.c
+++ b/src/drivers/storage/sdhci.c
@@ -789,8 +789,13 @@ static int sdhci_update(BlockDevCtrlrOps *me)
 		(me, SdhciHost, mmc_ctrlr.ctrlr.ops);
 
 	if (host->removable) {
-		int present = (sdhci_readl(host, SDHCI_PRESENT_STATE) &
-			       SDHCI_CARD_PRESENT) != 0;
+		int present;
+
+		if (host->cd_gpio)
+			present = gpio_get(host->cd_gpio);
+		else
+			present = (sdhci_readl(host, SDHCI_PRESENT_STATE) &
+				   SDHCI_CARD_PRESENT) != 0;
 
 		if (!present) {
 			if (host->mmc_ctrlr.media) {
diff --git a/src/drivers/storage/sdhci.h b/src/drivers/storage/sdhci.h
index 9e0c3f64d4e0..210a5ca064c0 100644
--- a/src/drivers/storage/sdhci.h
+++ b/src/drivers/storage/sdhci.h
@@ -24,6 +24,7 @@
 #include <libpayload.h>
 
 #include "mmc.h"
+#include "drivers/gpio/gpio.h"
 
 /*
  * Controller registers
@@ -314,6 +315,13 @@ struct sdhci_host {
 	/* Number of ADMA descriptors currently in the array. */
 	int adma_desc_count;
 
+	/*
+	 * Card detect GPIO. This is an optional property.
+	 * If no GPIO info is passed, the driver will use PRESENT_STATE
+	 * register to get card presence info.
+	 */
+	GpioOps *cd_gpio;
+
 	int (*attach)(SdhciHost *host);
 	void (*set_control_reg)(SdhciHost *host);
 };
-- 
The Qualcomm Innovation Center, Inc. is a member of the Code Aurora Forum,
a Linux Foundation Collaborative Project

